#!/usr/bin/env python

from mod_python import apache
import time
import string

#import ofss
import MySQLdb

encoding="cp1251"

client_side_xslt = False
document_root = "/home/psha/public_html/pyfss/"

ofss = apache.import_module("ofss", path=[document_root], autoreload = 1, log = 1)

FSSError = ofss.FSSError

if not client_side_xslt:
	import libxml2
	import libxslt

def user_agent(req):
	req.add_common_vars()
	if req.subprocess_env.has_key("HTTP_USER_AGENT"):
		return req.subprocess_env["HTTP_USER_AGENT"]
	return "unknown"

def is_ie(browser):
	if browser.find("MSIE") > 0:
		return True
	if browser.find("Gecko") > 0:
		return False
	if browser.find("Konqueror") > 0:
		return False
	if browser.find("Windows") > 0:
		return True
	return False

def add_counter(uri):
	db = MySQLdb.connect("localhost", "fss", "fssPASS", "fss")
	if not db:
		return
	curs = db.cursor()
	curs.execute("""SELECT count FROM counter WHERE page = "%s" """ % uri);
	row = curs.fetchone()
	counter = 0
	if row:
		counter = row[0]
	else:
		curs.execute("""INSERT INTO counter VALUES("%s", "0")""" % uri);
	curs.execute("""UPDATE counter SET count = count + 1 WHERE page = "%s" """ % uri);
	db.close()
	return counter + 1

class FSSXSLT:
	def __init__(self, path):
		self.path = path 
		xsltdoc = libxml2.parseFile(path)
		if not xsltdoc:
			raise FSSError("Unable to parse XML from %s" % path)
		self.__xslt = libxslt.parseStylesheetDoc(xsltdoc)
		if not self.__xslt:
			raise FSSError("Unable to load XSLT from %s" % path)
	def __del__(self):
		if self.__xslt:
			self.__xslt.freeStylesheet()
		if self.__xml:
			self.__xml.freeDoc()
		if self.__result:
			self.__result.freeDoc()
	def xslt(self, xml):
		self.__xml = libxml2.parseDoc(xml.xml())
		self.__result = self.__xslt.applyStylesheet(self.__xml, None)
		return self.__xslt.saveResultToString(self.__result)

def handle_module(req, xml, module):
	sub = apache.import_module(module, path=[document_root], autoreload = 1, log = 1)
	return sub.handler(req,xml)

def handler(req): 
	xml = ofss.FSSXML() 
	xml.data("<?xml-stylesheet type='text/xsl' href='fss.%s.xslt'?>\n" % encoding);
	xml.push("fss:response", "xmlns='http://www.w3.org/1999/xhtml' xmlns:fss='http://asp.mexmat.net/xmlns/fss'");
	timer = time.time()

	module = req.filename
	if module[0:len(document_root)] == document_root:
		module = module[len(document_root):]
		if len(module) > 3 and module[len(module)-3:] == ".py":
			module = module[0:len(module)-3]

	counter = 0
	try :
		xml.push("fss:body")
		modules = ["serverstat", "fastsearch", "showdir", "hostlist", "index"]
		if modules.count(module) == 0:
			module = "index"
			xml.data("<fss:error>Unknown module: %s </fss:error>\n" % module);
		handle_module(req, xml, module)
		counter = add_counter(module)
		xml.pop("fss:body")
	except FSSError, e:
		xml.pop("fss:body")
		xml.data("<fss:error>"+ e.msg() +"</fss:error>\n");
	except:
		xml.pop("fss:body")
		xml.data("<fss:error>Internal error</fss:error>\n");

	xml.push("fss:meta")
	xml.data("<fss:line>"+time.ctime()+"</fss:line>\n");
	xml.data("<fss:timer type='web'>%.3f</fss:timer>" % (timer - req.request_time))
	xml.data("<fss:timer type='query'>%.3f</fss:timer>" % (time.time() - timer))
	if not client_side_xslt:
		xml.data("<fss:timer type='xslt'><xslt-timing/></fss:timer>")
	xml.data("<fss:line>counter: %d</fss:line>\n" % counter)
	#xml.data("<fss:line>agent: %s</fss:line>\n" % user_agent(req))
	xml.pop()
	timer = time.time()
	if client_side_xslt:
		req.content_type="text/xml; charset=%s" % encoding;
		req.write(xml.xml());
		return apache.OK
	
	msie = is_ie(user_agent(req))
		
	xslt = FSSXSLT(document_root + "/fss.%s.xslt" % encoding)
	tmp = xslt.xslt(xml)

	if msie:
		req.content_type="text/html; charset=%s" % encoding;
		ind = tmp.find("<html")
		tmp = tmp[ind:]
		#tmp = tmp.replace('xmlns="http://www.w3.org/1999/xhtml"', "")
	else:
		req.content_type="application/xhtml+xml; charset=%s" % encoding;
	tmp = string.replace(tmp, "<xslt-timing/>", "%.3f" % (time.time() - timer))


	req.write(string.replace(tmp, 'xmlns:fss="http://asp.mexmat.net/xmlns/fss"', ""))
	return apache.OK 
